
import flash.display.Sprite;
import flash.display.StageAlign;
import flash.display.StageScaleMode;
import flash.events.ActivityEvent;
import flash.events.Event;
import flash.events.SampleDataEvent;
import flash.media.Microphone;
import flash.media.Sound;
import flash.media.SoundMixer;
import flash.system.Capabilities;
import flash.text.TextField;
import flash.utils.ByteArray;

private var buf:Vector.<Number>;
private var mic:Microphone;
private var sound:Sound;

public var sprite:Sprite;
public function init() {
	stage.align = StageAlign.TOP_LEFT;
	stage.scaleMode = StageScaleMode.NO_SCALE;
	
	var version:String = Capabilities.version;
	var vs:Array = version.split(/[, ]/);
	var v:Number = Number(vs[1]) + Number(vs[2]) / 10;
	if (v < 10.1) {
		var tf:TextField = new TextField();
		tf.width = 256;
		tf.height = 256;
		tf.appendText("Error\n");
		tf.appendText(" Flash Player 10.1 or later required.\n");
		tf.appendText(" Your Flash Player version: " + version);
		addChild(tf);
		return;
	}
	
	buf = new Vector.<Number>();
	
	mic = Microphone.getMicrophone();
	mic.rate = 44;
	mic.addEventListener(SampleDataEvent.SAMPLE_DATA, onMicSampleData);
	
	
	sprite = new Sprite();
	this.stage.addChild(sprite);
	
	sound = new Sound();
	sound.addEventListener(SampleDataEvent.SAMPLE_DATA, onSoundSampleData);
	sound.play();
}

// event.data から波形データを取得する。
private function onMicSampleData(event:SampleDataEvent):void {
	while (event.data.bytesAvailable) {
		var v:Number = event.data.readFloat();
		buf.push(v);
	}
}

public var barcode:String="";
// event.data に 8192サンプル分の波形データを追加する。
private function onSoundSampleData(event:SampleDataEvent):void {
	sprite.graphics.clear();
	sprite.graphics.lineStyle(0, 0x0000FF);
	sprite.graphics.moveTo(0, 100);
	
	var count:int = 0;
	var old_minus_flag:Boolean=false;
	
	for (var i:int = 0; i < 8192 && buf.length > 0; i++) {
		var v:Number = buf.shift();
		event.data.writeFloat(v); // 左
		event.data.writeFloat(v); // 右
		
		if(i%4==0 && (v*10 >5 || v*10 <-5 )){
			if(v*10>0){
				//マイナスからプラスに反転
				if(old_minus_flag){
					//マイナス=0扱いとする
					for(var j:int=1;j<=int(count/8);j++){
						barcode = barcode + "1";
					}
					count = 0;
				}
			}else{
				//プラスからマイナスに反転
				if(!old_minus_flag){
					//プラス＝1扱い
					for(var k:int=1;k<=int(count/8);k++){
						barcode = barcode + "0";
					}
					count = 0;
				}
			}
			if(barcode.length>=10*20){
				analyze(barcode);
				barcode = "";
			}
			
			
			count = count+1;
			
			sprite.graphics.lineTo(int(i/8), 100 - v*10);
			
			if(v*10>0){
				old_minus_flag = false;
			}else{
				old_minus_flag = true;
			}
		}
	}
	
	for (; i < 8192; i++) {
		event.data.writeFloat(0);
		event.data.writeFloat(0);
	}
	
}

public function analyze(barcode:String):void{
	var barcode_charcode:String = "";
	var barcode_char:String = "";
	var barcode_string:String = "";
	
	for(var i=0;i<=12;i++){
		var start:int = i*10+1;
		barcode_charcode = barcode.charAt(start+5)+barcode.charAt(start+4)+barcode.charAt(start+3)+barcode.charAt(start+2)+barcode.charAt(start+1)+barcode.charAt(start);
		var barcode_ascii_code:int = parseInt(barcode_charcode,2);
		
		if(barcode_ascii_code >= 48 && barcode_ascii_code <= 57){ 
			barcode_string = barcode_string + String.fromCharCode(barcode_ascii_code);
		}
		
		if(barcode_string.length > 12){
			barcode_text.text = barcode_string;
		}
		
	}
	
	
	
}

